# SourcePath: procps-ng/20191212dev
Summary: The /proc file system utilities.
Name: sony-target-dev-procps-ng
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-procps-ng
Version: 3.3.12
Release: 14000101
License: GPL2 / LGPL2
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
URL		: http://procps.sourceforge.net
Source		: procps-ng-%{version}.tar.xz
Source1		: sysctl.conf
Patch1		: procps-ng-3.3.12-CVE-2018-1122.patch
Patch2		: procps-ng-3.3.12-CVE-2018-1123.patch
Patch3		: procps-ng-3.3.12-CVE-2018-1124.patch
Patch4		: procps-ng-3.3.12-CVE-2018-1125.patch
Patch5		: procps-ng-3.3.12-CVE-2018-1126.patch
# LOT scripts
Source10: sony-procps-libopt-build-procps
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_target_relocation}
BuildRequires: %{sony_tool_triplet}-%{sony_target_dialect}-dev-ncurses
%define _docdir	%{sony_target_dir}%{sony_target_dev_doc_dir}

%description
These are utilities to browse the /proc filesystem, which is not a real file
system but a way for the kernel to provide information about the status of
entries in its process table. (e.g. running, stopped or "zombie")
Both command line and full screen utilities are provided. Ncurses is needed
for the full screen utilities.

%package -n %{pkgname}
Summary: The /proc file system utilities.
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
These are utilities to browse the /proc filesystem, which is not a real file
system but a way for the kernel to provide information about the status of
entries in its process table. (e.g. running, stopped or "zombie")
Both command line and full screen utilities are provided. Ncurses is needed
for the full screen utilities.

%prep
%setup -n procps-ng-%{version}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
%sony_target_dev_setup
export ac_cv_func_malloc_0_nonnull=yes
export ac_cv_func_realloc_0_nonnull=yes

sed -i "s|am__api_version='1.13'|am__api_version='1.15'|" configure
%sony_target_dev_configure --prefix=/usr --exec-prefix= --libdir=/usr/lib \
 --includedir=%{sony_target_dev_include_dir} --disable-nls 

make CC="$CC" AR="$AR" INCDIRS= CFLAGS="-O2 -s -fPIC -ffunction-sections"
#make INCDIRS= CFLAGS="-O2 -s -fPIC -ffunction-sections"

%install
rm -rf %{buildroot}
%sony_target_dev_install_setup
cd objdir;

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_sbin_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_include_dir}
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/man/man1
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/man/man5
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/man/man8
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/bin
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/sbin
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/lib
export DESTDIR=%{buildroot}%{sony_target_dir}
export INSTALLBIN="install --mode a=rx"

make CFLAGS="-O2 -s -fPIC -ffunction-sections" OWNERGROUP='' DESTDIR=$DESTDIR INSTALLBIN="$INSTALLBIN" ldconfig=echo install 

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}
install -m 644 ../sysctl.conf \
	%{buildroot}%{sony_target_dir}%{sony_target_dev_sysconf_dir}/

rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}
rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/bin/kill

mkdir -p ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_lib_dir}
mv ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_dev_lib_dir}/pkgconfig \
        ${RPM_BUILD_ROOT}%{sony_target_dir}%{sony_target_devtool_lib_dir}

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}`; do
    case $l in
        *.a|pkgconfig)
          mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l \
             %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
          ;;
    esac
done

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
    if [ "$l" != "pkgconfig" ]; then
        ln -s ../..%{sony_target_devtool_lib_dir}/$l \
            %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
    fi
done

# Begin for LOT

mkdir -p %{buildroot}%{sony_target_dir}/lib
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/procps-ng

# Set Library Optimizer variables
%define _optdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo
%define _libdir %{buildroot}%{sony_target_dir}/usr/lib

# Install Library Optimizer information (procps)
install -m 755 %{SOURCE10} %{_optdir}/procps-ng/build
install -m 644 proc/*.o %{_optdir}/procps-ng/
(cd %{_optdir}/procps-ng; umask 022; %{sony_cross_bin_dir}/%{sony_tool_triplet}-%{sony_target_dialect}-libindex %{_libdir}/libprocps.so.6.0.0 -o *.o > index)
(umask 022; echo "/usr/lib/libprocps.so.6.0.0" > %{_optdir}/procps-ng/path)

#END OF LOT
# move pidof /bin -> /usr/bin to resolve conflict with busybox pidof
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_dev_local_bin_dir}
mv %{buildroot}%{sony_target_dir}%{sony_target_dev_dir}/bin/pidof %{buildroot}%{sony_target_dir}%{sony_target_dev_local_bin_dir}/pidof

%clean
rm -rf %{buildroot}


%files -n %{pkgname}
%defattr(-,root,root,-)
##%{sony_target_dir}
%{sony_target_dir}%{sony_target_dev_dir}/bin/ps
%{sony_target_dir}%{sony_target_dev_dir}/sbin/sysctl
%{sony_target_dir}%{sony_target_dev_dir}/bin/free
%{sony_target_dir}%{sony_target_dev_dir}/bin/pgrep
%{sony_target_dir}%{sony_target_dev_dir}/bin/pkill
%{sony_target_dir}%{sony_target_dev_dir}/bin/pmap
%{sony_target_dir}%{sony_target_dev_dir}/bin/tload
%{sony_target_dir}%{sony_target_dev_dir}/bin/top
%{sony_target_dir}%{sony_target_dev_dir}/bin/uptime
%{sony_target_dir}%{sony_target_dev_dir}/bin/vmstat
%{sony_target_dir}%{sony_target_dev_dir}/bin/w
%{sony_target_dir}%{sony_target_dev_dir}/bin/watch
%{sony_target_dir}%{sony_target_dev_dir}/bin/pwdx
%{sony_target_dir}%{sony_target_dev_dir}/bin/slabtop
%{sony_target_dir}%{sony_target_dev_dir}%{sony_target_dev_local_bin_dir}/pidof
%{sony_target_dir}%{sony_target_dev_sysconf_dir}/sysctl.conf
%{sony_target_dir}%{sony_target_dev_include_dir}/*
%{sony_target_dir}%{sony_target_dev_lib_dir}/libprocps*
%{sony_target_dir}%{sony_target_devtool_lib_dir}/*.a
%{sony_target_dir}%{sony_target_devtool_lib_dir}/pkgconfig/libprocps.pc

# for LOT
%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/*

%changelog
* Mon Oct 12 2020 Sony Corporation
- Initial build for CE Linux 14.0.1.X

* Wed Feb 12 2020 Sony Corporation
- Added Patch for CVE-2018-1122 CVE-2018-1123
  CVE-2018-1124 CVE-2018-1125 CVE-2018-1126

* Thu May 18 2017 Sony Corporation
- Initial build.

